﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Controls.TransitionControl;
using System.Windows.Media.Imaging;
using System.Windows.Threading;

namespace RadTransitionControl_SL_567377
{
    public partial class MainPage : UserControl
    {
        private int counter = 0;
        private DispatcherTimer timer;

        public MainPage()
        {
            InitializeComponent();

            timer = new DispatcherTimer();
            timer.Interval = TimeSpan.FromSeconds(5);

            this.timer.Tick += new EventHandler(timer_Tick);

            this.NextImage();
        }

        private void NextImage()
        {
            string s = String.Format("http://localhost:10080/Cams/Cam.{0:00}.jpg", counter);
            LoadNewImage(s);
            counter++;
            if (counter > 3)
            {
                counter = 0;
            }
        }

        private void LoadNewImage(string uri)
        {
            BitmapImage bitmapImage = new BitmapImage();

            bitmapImage.ImageOpened += new EventHandler<RoutedEventArgs>(bitmapImage_ImageOpened);
            bitmapImage.ImageFailed += new EventHandler<ExceptionRoutedEventArgs>(bitmapImage_ImageFailed);
            bitmapImage.DownloadProgress += new EventHandler<DownloadProgressEventArgs>(bitmapImage_DownloadProgress);

            bitmapImage.UriSource = new Uri(uri, UriKind.RelativeOrAbsolute);
            bitmapImage.CreateOptions = BitmapCreateOptions.None;
        }

        void bitmapImage_DownloadProgress(object sender, DownloadProgressEventArgs e)
        {
        }

        private void bitmapImage_ImageFailed(object sender, ExceptionRoutedEventArgs e)
        {
            BitmapImage bitmapImage = (BitmapImage)sender;
            bitmapImage.ImageOpened -= new EventHandler<RoutedEventArgs>(bitmapImage_ImageOpened);
            bitmapImage.ImageFailed -= new EventHandler<ExceptionRoutedEventArgs>(bitmapImage_ImageFailed);
            bitmapImage.DownloadProgress -= new EventHandler<DownloadProgressEventArgs>(bitmapImage_DownloadProgress);
        }

        private void bitmapImage_ImageOpened(object sender, RoutedEventArgs e)
        {
            BitmapImage bitmapImage = (BitmapImage)sender;

            this.RadTC.Content = bitmapImage;
            this.timer.Start();

            bitmapImage.ImageOpened -= new EventHandler<RoutedEventArgs>(bitmapImage_ImageOpened);
            bitmapImage.ImageFailed -= new EventHandler<ExceptionRoutedEventArgs>(bitmapImage_ImageFailed);
            bitmapImage.DownloadProgress -= new EventHandler<DownloadProgressEventArgs>(bitmapImage_DownloadProgress);
        }

        void timer_Tick(object sender, EventArgs e)
        {
            this.NextImage();
            timer.Stop();
        }

        private void RadTC_TransitionStatusChanged(object sender, Telerik.Windows.Controls.TransitionControl.TransitionStatusChangedEventArgs e)
        {            
        }
    }
}
